precision highp float;

uniform sampler2D uTexture;
varying vec2 vTextureCoord;
varying vec2 vTextureCoord2;
varying vec4 vPosition;
uniform mat4 uPreRotation;
uniform mat4 uPostRotation;
uniform mat4 uRotMat;
uniform float uWidth;
uniform float uHeight;


void main() {

    float pi = 3.141592653589793;
    float xi = vPosition.x/uWidth + 0.5;
    float yi = vPosition.y/uHeight + 0.5;

    float phi = pi * yi;
    float theta = (1.0 - xi) * 2.0 * pi;

    float x = sin(phi) * cos(theta);
    float y = sin(phi) * sin(theta);
    float z = -cos(phi);

    vec4 pos = uPreRotation * vec4(x,y,z,1.0);
    pos = uPostRotation * pos;
    pos = uRotMat * pos;
    x = pos.x;
    y = pos.y;
    z = pos.z;


    phi = atan(sqrt(y * y + x * x),z);
    theta = atan(x , y);

    float v = phi / pi;

    float u = (1.0 - (theta + pi) / ( 2.0 * pi));

    vec2 textureCoord = vec2(u , v);

    gl_FragColor = texture2D(uTexture,textureCoord);

    gl_FragColor = texture2D(uTexture,textureCoord);

}