precision highp float;
uniform sampler2D uTexture;
varying vec2 vTextureCoord;
varying vec4 vPosition;
uniform int uFrameCounter;

void main() {
        vec2 coord = vec2(vTextureCoord.x,vTextureCoord.y);
     	vec2 minVal = vec2(0.0,0.0);
       	vec2 maxVal = vec2(1.0,1.0);
       	vec2 minCoord = max(coord , minVal);
       	vec2 maxCoord = min(coord , maxVal);
       	coord = clamp(coord , minVal ,maxVal);
       	gl_FragColor = texture2D(uTexture,coord);
        if(any(equal(minVal , minCoord)) || any(equal(maxVal , maxCoord))){
            gl_FragColor.a = 0.0;
            gl_FragColor.rgb *= gl_FragColor.a;
        }else if(uFrameCounter < 2){
            gl_FragColor = vec4(0.0,0.0,0.0,0.0);
        }
}