precision highp float;
uniform sampler2D uTexture;
varying vec2 vTextureCoord;
varying vec4 vPosition;
uniform mat4 uPreRotation;
uniform mat4 uPostRotation;
uniform mat4 uRotMat;

void main() {
    float pi = 3.141592653589793;
    float x = vPosition.x;
    float y = vPosition.z;
    float z = vPosition.y;

    vec4 pos = uPreRotation * vec4(x,y,z,1.0);
    pos = uPostRotation * pos;
    pos = uRotMat * pos;
    x = pos.x;
    y = pos.y;
    z = pos.z;


    float phi = atan(sqrt(y * y + z * z),x);

    float theta = atan(y , z);

    float v = phi / pi;

    float u = (theta + pi) / ( 2.0 * pi);

    vec2 textureCoord = vec2(u , v);

    gl_FragColor = texture2D(uTexture,textureCoord);

}