precision highp float;
uniform sampler2D uTexture;
varying highp vec4 vPosition;
varying highp vec2 vTextureCoord;
uniform float uClipAngle;
uniform float uWidth;
uniform float uHeight;
uniform mat4 uRotMat;

void main(void)
{
    gl_FragColor = texture2D(uTexture,vTextureCoord.xy);
    float pi = 3.14159265358979323846;
    float xi = vPosition.x/uWidth + 0.5;
    float yi = vPosition.y/uHeight + 0.5;

    float phi = pi * yi;
    float z = -cos(phi);
    float ringradius = sin(phi);
    float theta = pi * 2.0 * (1.0 - xi);
    float x = ringradius * cos(theta);
    float y = ringradius * sin(theta);

    vec4 pos = uRotMat * vec4(x,y,z,1.0);

    phi = atan(sqrt(pos.x * pos.x + pos.y * pos.y),pos.z);
    phi = phi/pi * 180.0;
    float blendAngle = 5.0/180.0 * pi;
    //sbs no blend
    if(uClipAngle/180.0 * pi - blendAngle < pi) {
        blendAngle = 0.0;
    }
    if(phi > uClipAngle/2.0 - blendAngle) {
        gl_FragColor.a = (uClipAngle/2.0 - phi)/blendAngle;
    }
}